/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/epiphany/epiphany.md'.  */

#ifndef GCC_TM_PREDS_H
#define GCC_TM_PREDS_H

#ifdef HAVE_MACHINE_MODES
extern bool general_operand (rtx, machine_mode);
extern bool address_operand (rtx, machine_mode);
extern bool register_operand (rtx, machine_mode);
extern bool pmode_register_operand (rtx, machine_mode);
extern bool scratch_operand (rtx, machine_mode);
extern bool immediate_operand (rtx, machine_mode);
extern bool const_int_operand (rtx, machine_mode);
extern bool const_double_operand (rtx, machine_mode);
extern bool nonimmediate_operand (rtx, machine_mode);
extern bool nonmemory_operand (rtx, machine_mode);
extern bool push_operand (rtx, machine_mode);
extern bool pop_operand (rtx, machine_mode);
extern bool memory_operand (rtx, machine_mode);
extern bool indirect_operand (rtx, machine_mode);
extern bool ordered_comparison_operator (rtx, machine_mode);
extern bool comparison_operator (rtx, machine_mode);
extern bool symbolic_operand (rtx, machine_mode);
extern bool call_address_operand (rtx, machine_mode);
extern bool call_operand (rtx, machine_mode);
extern bool gpr_operand (rtx, machine_mode);
extern bool any_gpr_operand (rtx, machine_mode);
extern bool add_reg_operand (rtx, machine_mode);
extern bool add_operand (rtx, machine_mode);
extern bool arith_operand (rtx, machine_mode);
extern bool arith_int_operand (rtx, machine_mode);
extern bool move_src_operand (rtx, machine_mode);
extern bool move_double_src_operand (rtx, machine_mode);
extern bool move_dest_operand (rtx, machine_mode);
extern bool stacktop_operand (rtx, machine_mode);
extern bool proper_comparison_operator (rtx, machine_mode);
extern bool addsub_operator (rtx, machine_mode);
extern bool cc_operand (rtx, machine_mode);
extern bool const0_operand (rtx, machine_mode);
extern bool const_float_1_operand (rtx, machine_mode);
extern bool cc_move_operand (rtx, machine_mode);
extern bool float_operation (rtx, machine_mode);
extern bool set_fp_mode_operand (rtx, machine_mode);
extern bool post_modify_address (rtx, machine_mode);
extern bool post_modify_operand (rtx, machine_mode);
extern bool memclob_operand (rtx, machine_mode);
extern bool nonsymbolic_immediate_operand (rtx, machine_mode);
extern bool misaligned_operand (rtx, machine_mode);
#endif /* HAVE_MACHINE_MODES */

#define CONSTRAINT_NUM_DEFINED_P 1
enum constraint_num
{
  CONSTRAINT__UNKNOWN = 0,
  CONSTRAINT_r,
  CONSTRAINT_Rcs,
  CONSTRAINT_Rsc,
  CONSTRAINT_Rct,
  CONSTRAINT_K,
  CONSTRAINT_L,
  CONSTRAINT_m,
  CONSTRAINT_o,
  CONSTRAINT_p,
  CONSTRAINT_U16,
  CONSTRAINT_CnL,
  CONSTRAINT_Cm1,
  CONSTRAINT_Cl1,
  CONSTRAINT_Cr1,
  CONSTRAINT_Car,
  CONSTRAINT_Rra,
  CONSTRAINT_Sra,
  CONSTRAINT_Cfm,
  CONSTRAINT_Rgs,
  CONSTRAINT_Rcc,
  CONSTRAINT_V,
  CONSTRAINT__l,
  CONSTRAINT__g,
  CONSTRAINT_i,
  CONSTRAINT_s,
  CONSTRAINT_n,
  CONSTRAINT_E,
  CONSTRAINT_F,
  CONSTRAINT_X,
  CONSTRAINT_Cal,
  CONSTRAINT_Csy,
  CONSTRAINT__LIMIT
};

extern enum constraint_num lookup_constraint_1 (const char *);
extern const unsigned char lookup_constraint_array[];

/* Return the constraint at the beginning of P, or CONSTRAINT__UNKNOWN if it
   isn't recognized.  */

static inline enum constraint_num
lookup_constraint (const char *p)
{
  unsigned int index = lookup_constraint_array[(unsigned char) *p];
  return (index == UCHAR_MAX
          ? lookup_constraint_1 (p)
          : (enum constraint_num) index);
}

extern bool (*constraint_satisfied_p_array[]) (rtx);

/* Return true if X satisfies constraint C.  */

static inline bool
constraint_satisfied_p (rtx x, enum constraint_num c)
{
  int i = (int) c - (int) CONSTRAINT_K;
  return i >= 0 && constraint_satisfied_p_array[i] (x);
}

static inline bool
insn_extra_register_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_r && c <= CONSTRAINT_Rct;
}

static inline bool
insn_extra_memory_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_m && c <= CONSTRAINT_o;
}

static inline bool
insn_extra_special_memory_constraint (enum constraint_num)
{
  return false;
}

static inline bool
insn_extra_relaxed_memory_constraint (enum constraint_num)
{
  return false;
}

static inline bool
insn_extra_address_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_p && c <= CONSTRAINT_p;
}

static inline void
insn_extra_constraint_allows_reg_mem (enum constraint_num c,
				      bool *allows_reg, bool *allows_mem)
{
  if (c >= CONSTRAINT_U16 && c <= CONSTRAINT_Cfm)
    return;
  if (c >= CONSTRAINT_Rgs && c <= CONSTRAINT_Rcc)
    {
      *allows_reg = true;
      return;
    }
  if (c >= CONSTRAINT_V && c <= CONSTRAINT__g)
    {
      *allows_mem = true;
      return;
    }
  (void) c;
  *allows_reg = true;
  *allows_mem = true;
}

static inline size_t
insn_constraint_len (char fc, const char *str ATTRIBUTE_UNUSED)
{
  switch (fc)
    {
    case 'C': return 3;
    case 'R': return 3;
    case 'S': return 3;
    case 'U': return 3;
    default: break;
    }
  return 1;
}

#define CONSTRAINT_LEN(c_,s_) insn_constraint_len (c_,s_)

extern enum reg_class reg_class_for_constraint_1 (enum constraint_num);

static inline enum reg_class
reg_class_for_constraint (enum constraint_num c)
{
  if (insn_extra_register_constraint (c))
    return reg_class_for_constraint_1 (c);
  return NO_REGS;
}

extern bool insn_const_int_ok_for_constraint (HOST_WIDE_INT, enum constraint_num);
#define CONST_OK_FOR_CONSTRAINT_P(v_,c_,s_) \
    insn_const_int_ok_for_constraint (v_, lookup_constraint (s_))

enum constraint_type
{
  CT_REGISTER,
  CT_CONST_INT,
  CT_MEMORY,
  CT_SPECIAL_MEMORY,
  CT_RELAXED_MEMORY,
  CT_ADDRESS,
  CT_FIXED_FORM
};

static inline enum constraint_type
get_constraint_type (enum constraint_num c)
{
  if (c >= CONSTRAINT_p)
    {
      if (c >= CONSTRAINT_U16)
        return CT_FIXED_FORM;
      return CT_ADDRESS;
    }
  if (c >= CONSTRAINT_m)
    return CT_MEMORY;
  if (c >= CONSTRAINT_K)
    return CT_CONST_INT;
  return CT_REGISTER;
}
#endif /* tm-preds.h */
